﻿Imports System.Data
Imports System.Data.SqlClient
Imports System.Runtime.Serialization

<Serializable()> _
Public Class Customers
    Inherits MicroFour.StrataFrame.Business.BusinessLayer

#Region " Constructors "

	''' <summary>
    ''' Initializes a new instance of the Customers class.
    ''' </summary>
    ''' <remarks></remarks>
    <System.Diagnostics.DebuggerNonUserCodeAttribute()> _
    Public Sub New()
        MyBase.New()
        'This call is required by the Component Designer.
        Me.InitializeComponent()
        '-- Add the necessary handlers
        Me.AddHandlers()
    End Sub

    ''' <summary>
    ''' Initializes a new instance of the Customers class.
    ''' </summary>
    ''' <param name="Container">The IContainer to which this object will be added.</param>
    ''' <remarks></remarks>
    <System.Diagnostics.DebuggerNonUserCodeAttribute()> _
    Public Sub New(ByVal Container As System.ComponentModel.IContainer)
        MyBase.New()
        'This call adds the component to the given container.
        Container.Add(Me)
        'This call is required by the Component Designer.
        Me.InitializeComponent()
        '-- Add the necessary handlers
        Me.AddHandlers()
    End Sub

    ''' <summary>
    ''' Initializes a new instance of the Customers class.
    ''' </summary>
    ''' <param name="info">The SerializationInfo for the object.</param>
    ''' <param name="context">The StreamingContext for the source stream.</param>
    ''' <remarks></remarks>
    Protected Sub New(ByVal info As SerializationInfo, ByVal context As StreamingContext)
        MyBase.New(info, context)
        'This call is required by the Component Designer.
        Me.InitializeComponent()
        '-- Add the necessary handlers
        Me.AddHandlers()
    End Sub
    
    ''' <summary>
    ''' Adds the necessary handlers for the Customers class.
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub AddHandlers()
		AddHandler Me.CheckRulesOnCurrentRow, AddressOf Customers_CheckRulesOnCurrentRow
		AddHandler Me.SetDefaultValues, AddressOf Customers_SetDefaultValues
    End Sub
    
#End Region 

#Region " Data Retrieval Methods "

    Public Function GetCustomers(ByVal CustomerName As String) As DataTable

        Dim dt As New DataTable
        Dim loSQL As New SqlCommand
        Dim llLastNameSearch As Boolean = False

        If CustomerName.Contains(",") Then
            '------------------------------------------------------------------------------
            ' They are looking for the First Name now ... since each key press sends them 
            ' to the server in this design.  You have to make amends for the comma and the 
            ' space and then invoke the new SQL Statement with the first valid
            ' character of the first name.
            '------------------------------------------------------------------------------
            Dim FirstName As String = String.Empty
            Dim LastName As String = String.Empty
            Dim Names(1) As String

            Names = CustomerName.Split(",")

            '-----------------------------------------------------------------------------
            ' Normally I would put these guys into a stored procedure but I wanted to keep
            ' the intrusion into the StrataFrame Samples database at a minimum, so,
            ' I used the CommandType of CommandType.Text vice CommandType.StoredProcedure
            ' and set it up this way.
            '-----------------------------------------------------------------------------
            If Names.Length = 1 Then
                llLastNameSearch = True
            Else
                LastName = Names(0).Trim()
                FirstName = Names(1).Trim()

                If FirstName = "" Then
                    llLastNameSearch = True
                Else
                    CustomerName = CustomerName.Replace(",", "")
                    loSQL.CommandText = "SELECT TOP 20 RTRIM( cust_LastName ) + " + _
                                        "', ' + RTRIM( cust_FirstName ) + ' ' + " + _
                                        "RTRIM( cust_LastName) AS CustomerName " + _
                                        "FROM Customers WHERE " + _
                                        "cust_LastName LIKE @LastName AND " + _
                                        "cust_FirstName LIKE @FirstName " + _
                                        "ORDER BY cust_LastName, cust_FirstName"

                    loSQL.CommandType = CommandType.Text
                    loSQL.Parameters.Add("@LastName", SqlDbType.NVarChar, 60)
                    loSQL.Parameters("@LastName").Value = LastName.Trim + "%"

                    loSQL.Parameters.Add("@FirstName", SqlDbType.NVarChar, 60)
                    loSQL.Parameters("@FirstName").Value = FirstName.Trim() + "%"
                    dt = Me.GetDataTable(loSQL)
                End If
            End If

        Else
            llLastNameSearch = True
        End If

        If llLastNameSearch Then
            CustomerName = CustomerName.Replace(",", "")
            loSQL.CommandText = "SELECT TOP 20 RTRIM( cust_LastName ) + ', ' + " + _
                                "RTRIM( cust_FirstName ) + ' ' + " + _
                                "RTRIM( cust_LastName) AS CustomerName " + _
                                "FROM Customers " + _
                                "WHERE cust_LastName LIKE @LastName " + _
                                "ORDER BY cust_LastName, cust_FirstName"
            loSQL.CommandType = CommandType.Text
            loSQL.Parameters.Add("@LastName", SqlDbType.NVarChar, 60)
            loSQL.Parameters("@LastName").Value = CustomerName.Trim() + "%"
            dt = Me.GetDataTable(loSQL)
        End If



        Return dt

    End Function


#End Region

#Region " Event Handlers "

    ''' <summary>
    ''' Checks the business rules on the current row
    ''' </summary>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub Customers_CheckRulesOnCurrentRow(ByVal e As MicroFour.StrataFrame.Business.CheckRulesEventArgs)

    End Sub

    ''' <summary>
    ''' Sets the default values for a new row
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub Customers_SetDefaultValues()

    End Sub

#End Region

End Class
