﻿Imports System.Data
Imports System.Data.SqlClient
Imports System.Runtime.Serialization

Public Enum NetFlixNR As Integer
    Title = 0
    Link = 1
    ItemID = 2
    Description = 3
End Enum

<Serializable()> _
Public Class NetFlix
    Inherits MicroFour.StrataFrame.Business.BusinessLayer

#Region " Constructors "

	''' <summary>
    ''' Initializes a new instance of the NetFlix class.
    ''' </summary>
    ''' <remarks></remarks>
    <System.Diagnostics.DebuggerNonUserCodeAttribute()> _
    Public Sub New()
        MyBase.New()
        'This call is required by the Component Designer.
        Me.InitializeComponent()
        '-- Add the necessary handlers
        Me.AddHandlers()
    End Sub

    ''' <summary>
    ''' Initializes a new instance of the NetFlix class.
    ''' </summary>
    ''' <param name="Container">The IContainer to which this object will be added.</param>
    ''' <remarks></remarks>
    <System.Diagnostics.DebuggerNonUserCodeAttribute()> _
    Public Sub New(ByVal Container As System.ComponentModel.IContainer)
        MyBase.New()
        'This call adds the component to the given container.
        Container.Add(Me)
        'This call is required by the Component Designer.
        Me.InitializeComponent()
        '-- Add the necessary handlers
        Me.AddHandlers()
    End Sub

    ''' <summary>
    ''' Initializes a new instance of the NetFlix class.
    ''' </summary>
    ''' <param name="info">The SerializationInfo for the object.</param>
    ''' <param name="context">The StreamingContext for the source stream.</param>
    ''' <remarks></remarks>
    Protected Sub New(ByVal info As SerializationInfo, ByVal context As StreamingContext)
        MyBase.New(info, context)
        'This call is required by the Component Designer.
        Me.InitializeComponent()
        '-- Add the necessary handlers
        Me.AddHandlers()
    End Sub
    
    ''' <summary>
    ''' Adds the necessary handlers for the NetFlix class.
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub AddHandlers()
		AddHandler Me.CheckRulesOnCurrentRow, AddressOf NetFlix_CheckRulesOnCurrentRow
		AddHandler Me.SetDefaultValues, AddressOf NetFlix_SetDefaultValues
    End Sub
    
#End Region 

#Region " Data Retrieval Methods "

    Public Function GetNewReleases(ByVal DateOfImport As String) As DataTable

        Me.Clear()

        Dim loSQL As New SqlCommand
        loSQL.CommandText = "SELECT * FROM NetFlix WHERE nf_download_date >= @StartDate AND nf_download_date <= @EndDate ORDER BY nf_title"
        loSQL.CommandType = CommandType.Text
        loSQL.Parameters.Add("@StartDate", SqlDbType.DateTime)
        loSQL.Parameters("@StartDate").Value = CDate(DateOfImport + " 00:00:01 AM")
        loSQL.Parameters.Add("@EndDate", SqlDbType.DateTime)
        loSQL.Parameters("@EndDate").Value = CDate(DateOfImport + " 11:59:59 PM")

        Return Me.GetDataTable(loSQL)

    End Function

#End Region

#Region " Event Handlers "

    ''' <summary>
    ''' Checks the business rules on the current row
    ''' </summary>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub NetFlix_CheckRulesOnCurrentRow(ByVal e As MicroFour.StrataFrame.Business.CheckRulesEventArgs)

    End Sub

    ''' <summary>
    ''' Sets the default values for a new row
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub NetFlix_SetDefaultValues()
        Me.nf_description = String.Empty
        Me.nf_download_date = System.DateTime.Now
        Me.nf_favorite = False
        Me.nf_item_id = 0
        Me.nf_link = String.Empty
        Me.nf_atag = String.Empty
        Me.nf_title = String.Empty
    End Sub

#End Region

#Region " Processing "

    Public Function ImportNewReleases(ByVal dtNewReleases As DataTable) As Integer

        Me.Clear()
        Dim dr As DataRow

        For Each dr In dtNewReleases.Rows

            Me.NewRow()

            Dim NRDescription As String = dr(NetFlixNR.Description)
            Dim NRDescItems(5) As String

            NRDescItems = NRDescription.Split(">")
            Try
                Me.nf_title = dr(NetFlixNR.Title)
                Me.nf_link = dr(NetFlixNR.Link)
                Me.nf_description = Me.GetNRDescription(NRDescItems)
                Me.nf_atag = Me.GetNRATAG(NRDescItems)
                Me.nf_item_id = Me.GetNRUniqueID(NRDescItems)
                Try
                    If Me.Save() = MicroFour.StrataFrame.Data.SaveUndoResult.Success Then
                    Else
                        Me.DeleteCurrentRow()
                    End If
                Catch ex As Exception
                    Me.DeleteCurrentRow()
                End Try
            Catch ex As Exception
                Me.DeleteCurrentRow()
            End Try

        Next

        Me.Sort = "nf_title"

        Return Me.Count

    End Function

    Protected Function GetNRDescription(ByVal NRDescItems() As String) As String

        Dim NRDescription As String = NRDescItems(4)

        Return NRDescription

    End Function

    Protected Function GetNRATAG(ByVal NRDescItems() As String) As String

        Dim NRATag As String = ""

        NRATag = NRDescItems(0) + ">" + _
                 NRDescItems(1) + ">" + _
                 NRDescItems(2) + ">"

        Return NRATag

    End Function

    Protected Function GetNRUniqueID(ByVal NRDescItems() As String) As Integer

        Dim StringUID(6) As String
        StringUID = NRDescItems(0).Split("/")

        Dim NRUniqueID As Integer = StringUID(5).Substring(0, StringUID(5).Length - 2)

        Return NRUniqueID

    End Function

#End Region

End Class

'public partial class Rating_Rated : System.Web.UI.Page
'{
'    protected void Page_Load(object sender, EventArgs e)
'    {
'        if (!IsPostBack)
'        {


'            if ((Convert.ToInt32(Request.QueryString["Rating"]) == 1) || (Convert.ToInt32(Request.QueryString["Rating"]) == 2) || (Convert.ToInt32(Request.QueryString["Rating"]) == 3) || (Convert.ToInt32(Request.QueryString["Rating"]) == 4) || (Convert.ToInt32(Request.QueryString["Rating"]) == 5))
'            {
'                Label1.Text = "<IMG src='images/" + Request.QueryString["rating"] + "star.gif'>";
'                Label2.Text = "<IMG src='images/saved.gif'>";
'            }
'            else
'            {
'                Response.Redirect("Rate.aspx?id=" + Convert.ToInt32(Request.QueryString["id"]));
'            }



'            string p = "Select * from TEST_TABLE1 WHERE id = '1'";

'            clsDataAccess myDAR = new clsDataAccess();
'            myDAR.openConnection();
'            double myRatedBy = Convert.ToInt32(myDAR.getValue(p, Convert.ToInt32(ConfigurationSettings.AppSettings["RatedByField"])));
'            double myScore = Convert.ToDouble(myDAR.getValue(p, Convert.ToInt32(ConfigurationSettings.AppSettings["ScoreField"])));


'            double myCRating = Convert.ToDouble(Request.QueryString["Rating"]);

'            double myTotalRating = 0.0;

'            if ((Convert.ToInt32(Request.QueryString["Rating"]) == 1) || (Convert.ToInt32(Request.QueryString["Rating"]) == 2) || (Convert.ToInt32(Request.QueryString["Rating"]) == 3) || (Convert.ToInt32(Request.QueryString["Rating"]) == 4) || (Convert.ToInt32(Request.QueryString["Rating"]) == 5))
'                myTotalRating = (myScore + myCRating) / (myRatedBy + 1);
'            else
'                myTotalRating = (myScore) / (myRatedBy);

'            myDAR.closeConnection();

'            string myTotalRatingString = "";

'            if ((myTotalRating < 1) && (myTotalRating > 0))
'                myTotalRatingString = ".5";
'            else if (myTotalRating == 1.0)
'                myTotalRatingString = "1";
'            else if ((myTotalRating > 1) && (myTotalRating < 2))
'                myTotalRatingString = "1.5";
'            else if (myTotalRating == 2.0)
'                myTotalRatingString = "2";
'            else if ((myTotalRating > 2) && (myTotalRating < 3))
'                myTotalRatingString = "2.5";
'            else if (myTotalRating == 3.0)
'                myTotalRatingString = "3";
'            else if ((myTotalRating > 3) && (myTotalRating < 4))
'                myTotalRatingString = "3.5";
'            else if (myTotalRating == 4.0)
'                myTotalRatingString = "4";
'            else if ((myTotalRating > 4) && (myTotalRating < 5))
'                myTotalRatingString = "4.5";
'            else if (myTotalRating == 5.0)
'                myTotalRatingString = "5";



'            Label3.Text = "<IMG src='images/stars" + myTotalRatingString + ".gif'>";

'            int RatedBy = 0;
'            int TRating = 0;
'            if ((Convert.ToInt32(Request.QueryString["Rating"]) == 1) || (Convert.ToInt32(Request.QueryString["Rating"]) == 2) || (Convert.ToInt32(Request.QueryString["Rating"]) == 3) || (Convert.ToInt32(Request.QueryString["Rating"]) == 4) || (Convert.ToInt32(Request.QueryString["Rating"]) == 5))
'            {
'                RatedBy = Convert.ToInt32(myRatedBy) + 1;
'                TRating = Convert.ToInt32(myScore) + Convert.ToInt32(Request.QueryString["rating"]);
'            }
'            else
'            {
'                RatedBy = Convert.ToInt32(myRatedBy);
'                TRating = Convert.ToInt32(myScore);
'            }

'            string q = "UPDATE TEST_TABLE  SET Score = '" + TRating + " ' , RatedBy = '" + RatedBy + "' WHERE id = '1'";

'            clsDataAccess myDA = new clsDataAccess();
'            myDA.openConnection();
'            myDA.saveData(q);
'            myDA.closeConnection();

'            if ((Convert.ToInt32(Request.QueryString["Rating"]) == 1) || (Convert.ToInt32(Request.QueryString["Rating"]) == 2) || (Convert.ToInt32(Request.QueryString["Rating"]) == 3) || (Convert.ToInt32(Request.QueryString["Rating"]) == 4) || (Convert.ToInt32(Request.QueryString["Rating"]) == 5))
'            {
'                Response.Cookies["RatedAmz" + Convert.ToInt32(Request.QueryString["id"])].Value = Request.QueryString["Rating"].ToString();
'            }


'        }
'    }
'}
