﻿Option Strict On
Option Explicit On

Imports MicroFour.StrataFrame.Business
Imports MicroFour.StrataFrame.Security
Imports MicroFour.StrataFrame.UI.Windows.Forms
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Data
Imports System.IO

Partial Public Class Products

#Region " Component Implementation "

    <System.Diagnostics.DebuggerNonUserCodeAttribute()> _
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If (disposing _
           AndAlso (Not (Me.components) Is Nothing)) Then
            Me.components.Dispose()
        End If
        MyBase.Dispose(disposing)
    End Sub

    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Component Designer
    'It can be modified using the Component Designer.
    'Do not modify it using the code editor.
    <System.Diagnostics.DebuggerNonUserCodeAttribute()> _
    Private Sub InitializeComponent()
        '
        'Products
        '
    End Sub

#End Region

#Region " BusinessLayer Overriden Methods & Properties "

    ''' <summary>
    ''' The collection of required fields for the business object.
    ''' </summary>
    ''' <remarks></remarks>
    <Browsable(False), DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)> _
    Public Overrides Property RequiredFields() As RequiredFieldsCollection
        Get
            Return MyBase.RequiredFields
        End Get
        Set(ByVal value As RequiredFieldsCollection)
            MyBase.RequiredFields = value
        End Set
    End Property

    ''' <summary>
    ''' Defines the constraint that defines the parent-child relationship between this business object type and another business object type.
    ''' </summary>
    ''' <remarks></remarks>
    <Browsable(False), DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)> _
    Public Overrides Property ParentRelationship() As IBusinessParentRelationship
        Get
            Return MyBase.ParentRelationship
        End Get
        Set(ByVal value As IBusinessParentRelationship)
            MyBase.ParentRelationship = value
        End Set
    End Property

    ''' <summary>
    ''' Returns all of the field names in a single string in the form of [field1],[field2],...  This must be used in the place of '*' in select statements if Query Notifications are to be registered.
    ''' </summary>
    ''' <remarks></remarks>
    Protected Overrides ReadOnly Property AllFieldNames() As String
        Get
            Return "[prod_pk],[prod_SKU],[prod_Name],[prod_Desc],[prod_Price],[prod_Image],[prod_IsActive],[prod_Created],[prod_Version]"
        End Get
    End Property

    ''' <summary>
    ''' The name of the database that contains the table to which this business object is mapped.
    ''' </summary>
    ''' <remarks></remarks>
    Public Overrides ReadOnly Property Database() As String
        Get
            Return "StrataFrameSample"
        End Get
    End Property

    Private Shared _PrimaryKeyFields As String() = New String() {"prod_pk"}
    ''' <summary>
    ''' Gets the field or fields that comprise the primary key for the business object.
    ''' </summary>
    ''' <remarks></remarks>
    Public Overrides ReadOnly Property PrimaryKeyFields() As String()
        Get
            Return _PrimaryKeyFields
        End Get
    End Property

    ''' <summary>
    ''' The name of the table in the database to which this business object is mapped.
    ''' </summary>
    ''' <remarks></remarks>
    Public Overrides ReadOnly Property TableName() As String
        Get
            Return "Products"
        End Get
    End Property

    ''' <summary>
    ''' The schema of the table in the database to which this business object is mapped.
    ''' </summary>
    ''' <remarks></remarks>
    Public Overrides ReadOnly Property TableSchema() As String
        Get
            Return "dbo"
        End Get
    End Property

    ''' <summary>
    ''' Creates and returns an array of DataColumns that contains the schema for the table.  This is used to prevent a round trip to the server to aquire the initial schema for the internal DataTable.
    ''' </summary>
    ''' <remarks></remarks>
    Protected Overrides Function CreateTableSchema() As DataColumn()
        Return New DataColumn() { _
        New DataColumn("prod_pk", GetType(System.Int32)), _
        New DataColumn("prod_SKU", GetType(System.String)), _
        New DataColumn("prod_Name", GetType(System.String)), _
        New DataColumn("prod_Desc", GetType(System.String)), _
        New DataColumn("prod_Price", GetType(System.Decimal)), _
        New DataColumn("prod_Image", GetType(System.Byte())), _
        New DataColumn("prod_IsActive", GetType(System.Boolean)), _
        New DataColumn("prod_Created", GetType(System.DateTime)), _
        New DataColumn("prod_Version", GetType(System.Int32))}
    End Function

    ''' <summary>
    ''' Adds a broken rule to the business object's collection
    ''' </summary>
    ''' <remarks></remarks>
    Protected Shadows Sub AddBrokenRule(ByVal Field As ProductsFieldNames, ByVal ErrorMessage As String)
        MyBase.AddBrokenRule(Field, ErrorMessage)
    End Sub

    ''' <summary>
    ''' Adds a broken rule to the business object's collection
    ''' </summary>
    ''' <remarks></remarks>
    Protected Shadows Sub AddBrokenRule(ByVal FieldName As String, ByVal ErrorMessage As String)
        MyBase.AddBrokenRule(FieldName, ErrorMessage)
    End Sub

    ''' <summary>
    ''' Adds a broken rules to the business object's collection using the given message key to pull the error message from the localization database
    ''' </summary>
    ''' <remarks></remarks>
    Protected Shadows Sub AddBrokenRuleByKey(ByVal Field As ProductsFieldNames, ByVal ErrorMessageKey As String)
        MyBase.AddBrokenRuleByKey(Field, ErrorMessageKey)
    End Sub

    ''' <summary>
    ''' Adds a broken rules to the business object's collection using the given message key to pull the error message from the localization database
    ''' </summary>
    ''' <remarks></remarks>
    Protected Shadows Sub AddBrokenRuleByKey(ByVal FieldName As String, ByVal ErrorMessageKey As String)
        MyBase.AddBrokenRuleByKey(FieldName, ErrorMessageKey)
    End Sub

    ''' <summary>
    ''' Gets a collection of the names for all fields that belong to this business object and map to the database.
    ''' </summary>
    ''' <remarks></remarks>
    Public Overrides ReadOnly Property AllFieldsList() As List(Of String)
        Get
            Return _AllFieldsList
        End Get
    End Property

    ''' <summary>
    ''' Gets a dictionary of the DbTypes for all fields that belong to this business object and map to the database.
    ''' </summary>
    ''' <remarks></remarks>
    Public Overrides ReadOnly Property FieldDbTypes() As Dictionary(Of String, DbType)
        Get
            Return _FieldDbTypes
        End Get
    End Property

    ''' <summary>
    ''' Gets a dictionary of all fields within this business object that map to the FieldNames enumeration for this business object.
    ''' </summary>
    ''' <remarks></remarks>
    Public Overrides ReadOnly Property FieldEnums() As BusinessLayerFieldEnumDictionary
        Get
            Return _FieldEnums
        End Get
    End Property

    ''' <summary>
    ''' Gets a dictionary of all of the lengths for all fields within this business object that map to a field in the database.
    ''' </summary>
    ''' <remarks></remarks>
    Public Overrides ReadOnly Property FieldLengths() As Dictionary(Of String, Integer)
        Get
            Return _FieldLengths
        End Get
    End Property

    ''' <summary>
    ''' Gets a dictionary of the native DbType (SqlDbType, OracleType, OleDbType, etc.) for all fields within this buisness object that map to a field in the database.
    ''' </summary>
    ''' <remarks></remarks>
    Public Overrides ReadOnly Property FieldNativeDbTypes() As Dictionary(Of String, Integer)
        Get
            Return _FieldNativeDbTypes
        End Get
    End Property

    ''' <summary>
    ''' Gets a dictionary of the security permission keys for each field in the business object.
    ''' </summary>
    ''' <remarks></remarks>
    Public Overrides ReadOnly Property FieldPermissionKeys() As Dictionary(Of String, String)
        Get
            Return _FieldPermissionKeys
        End Get
    End Property

#End Region

#Region " Field Properties "

    ''' <summary>
    ''' prod_pk
    ''' </summary>
    ''' <remarks></remarks>
    <Browsable(False), _
     BusinessFieldDisplayInEditor(), _
     Description("prod_pk"), _
     DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)> _
    Public Property [prod_pk]() As System.Int32
        Get
            Return CType(Me.CurrentRow.Item("prod_pk"), System.Int32)
        End Get
        Set(ByVal value As System.Int32)
            Me.CurrentRow.Item("prod_pk") = value
        End Set
    End Property

    ''' <summary>
    ''' prod_SKU
    ''' </summary>
    ''' <remarks></remarks>
    <Browsable(False), _
     BusinessFieldDisplayInEditor(), _
     Description("prod_SKU"), _
     DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)> _
    Public Property [prod_SKU]() As System.String
        Get
            Return CType(Me.CurrentRow.Item("prod_SKU"), System.String)
        End Get
        Set(ByVal value As System.String)
            Me.CurrentRow.Item("prod_SKU") = value
        End Set
    End Property

    ''' <summary>
    ''' prod_Name
    ''' </summary>
    ''' <remarks></remarks>
    <Browsable(False), _
     BusinessFieldDisplayInEditor(), _
     Description("prod_Name"), _
     DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)> _
    Public Property [prod_Name]() As System.String
        Get
            Return CType(Me.CurrentRow.Item("prod_Name"), System.String)
        End Get
        Set(ByVal value As System.String)
            Me.CurrentRow.Item("prod_Name") = value
        End Set
    End Property

    ''' <summary>
    ''' prod_Desc
    ''' </summary>
    ''' <remarks></remarks>
    <Browsable(False), _
     BusinessFieldDisplayInEditor(), _
     Description("prod_Desc"), _
     DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)> _
    Public Property [prod_Desc]() As System.String
        Get
            Return CType(Me.CurrentRow.Item("prod_Desc"), System.String)
        End Get
        Set(ByVal value As System.String)
            Me.CurrentRow.Item("prod_Desc") = value
        End Set
    End Property

    ''' <summary>
    ''' prod_Price
    ''' </summary>
    ''' <remarks></remarks>
    <Browsable(False), _
     BusinessFieldDisplayInEditor(), _
     Description("prod_Price"), _
     DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)> _
    Public Property [prod_Price]() As System.Decimal
        Get
            Return CType(Me.CurrentRow.Item("prod_Price"), System.Decimal)
        End Get
        Set(ByVal value As System.Decimal)
            Me.CurrentRow.Item("prod_Price") = value
        End Set
    End Property

    ''' <summary>
    ''' prod_Image
    ''' </summary>
    ''' <remarks></remarks>
    <Browsable(False), _
     BusinessFieldDisplayInEditor(), _
     Description("prod_Image"), _
     DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)> _
    Public Property [prod_Image]() As System.Byte()
        Get
            Return CType(Me.CurrentRow.Item("prod_Image"), System.Byte())
        End Get
        Set(ByVal value As System.Byte())
            Me.CurrentRow.Item("prod_Image") = value
        End Set
    End Property

    ''' <summary>
    ''' prod_IsActive
    ''' </summary>
    ''' <remarks></remarks>
    <Browsable(False), _
     BusinessFieldDisplayInEditor(), _
     Description("prod_IsActive"), _
     DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)> _
    Public Property [prod_IsActive]() As System.Boolean
        Get
            Return CType(Me.CurrentRow.Item("prod_IsActive"), System.Boolean)
        End Get
        Set(ByVal value As System.Boolean)
            Me.CurrentRow.Item("prod_IsActive") = value
        End Set
    End Property

    ''' <summary>
    ''' prod_Created
    ''' </summary>
    ''' <remarks></remarks>
    <Browsable(False), _
     BusinessFieldDisplayInEditor(), _
     Description("prod_Created"), _
     DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)> _
    Public Property [prod_Created]() As System.DateTime
        Get
            Return CType(Me.CurrentRow.Item("prod_Created"), System.DateTime)
        End Get
        Set(ByVal value As System.DateTime)
            Me.CurrentRow.Item("prod_Created") = value
        End Set
    End Property

    ''' <summary>
    ''' prod_Version
    ''' </summary>
    ''' <remarks></remarks>
    <Browsable(False), _
     BusinessFieldDisplayInEditor(), _
     Description("prod_Version"), _
     DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)> _
    Public Property [prod_Version]() As System.Int32
        Get
            Return CType(Me.CurrentRow.Item("prod_Version"), System.Int32)
        End Get
        Set(ByVal value As System.Int32)
            Me.CurrentRow.Item("prod_Version") = value
        End Set
    End Property

#End Region

#Region " Field Property Events  "

#End Region

#Region " Nested Types & Field Security "

    ''' <summary>
    ''' Contains all of the field names that belong to the business object.
    ''' </summary>
    ''' <remarks></remarks>
    Public Enum ProductsFieldNames As Integer
        [prod_pk]
        [prod_SKU]
        [prod_Name]
        [prod_Desc]
        [prod_Price]
        [prod_Image]
        [prod_IsActive]
        [prod_Created]
        [prod_Version]
        CUSTOM_FIELD
    End Enum

    ''' <summary>
    ''' Gets the System.Type of the enumeration that contains the field names for the business object.
    ''' </summary>
    ''' <remarks></remarks>
    Public Overrides Function GetFieldEnumType() As System.Type
        Return GetType(ProductsFieldNames)
    End Function

    ''' <summary>
    ''' Creates a new CheckFieldSecurityEventArgs object that can be used with this business object type.
    ''' </summary>
    ''' <remarks></remarks>
    Protected Overrides Function CreateNewFieldSecurityEventArgs(ByVal Field As System.Enum, ByVal CustomField As String, ByVal PermissionKey As String, ByVal Perm As PermissionInfo) As CheckFieldSecurityEventArgsBase
        Return New CheckFieldSecurityEventArgs(Of ProductsFieldNames)(Field, CustomField, PermissionKey, Perm)
    End Function

    ''' <summary>
    ''' Describes a method that will handle the CheckFieldScurity event.
    ''' </summary>
    ''' <remarks></remarks>
    Public Delegate Sub CheckFieldSecurityEventHandler(ByVal sender As Object, ByVal e As CheckFieldSecurityEventArgs(Of ProductsFieldNames))

    ''' <summary>
    ''' Occurs when the business objects needs to check the security on a field.
    ''' </summary>
    ''' <remarks></remarks>
    Public Event CheckFieldSecurity As CheckFieldSecurityEventHandler

    ''' <summary>
    ''' Raises the CheckFieldSecurity event.
    ''' </summary>
    ''' <remarks></remarks>
    Protected Overrides Sub OnCheckFieldSecurity(ByVal e As CheckFieldSecurityEventArgsBase)
        RaiseEvent CheckFieldSecurity(Me, CType(e, CheckFieldSecurityEventArgs(Of ProductsFieldNames)))
    End Sub

#End Region

#Region " Item Property Implementation "


    Private Shared _AllFieldsList As List(Of String)
    Private Shared _FieldDbTypes As Dictionary(Of String, DbType)
    Private Shared _FieldEnums As BusinessLayerFieldEnumDictionary
    Private Shared _FieldLengths As Dictionary(Of String, Integer)
    Private Shared _FieldNativeDbTypes As Dictionary(Of String, Integer)
    Private Shared _FieldPermissionKeys As Dictionary(Of String, String)

    ''' <summary>
    ''' Initializes the shared members of the Products class.
    ''' </summary>
    ''' <remarks></remarks>
    Shared Sub New()
        '-- Create the new shared dictionary and populate it with an 
        '   instance of each property descriptor
        _PropertyDescriptors = New PropertyDescriptorDictionary(14)
        _PropertyDescriptors.Add("prod_pk", New Field_prod_pk_Descriptor())
        _PropertyDescriptors.Add("prod_SKU", New Field_prod_SKU_Descriptor())
        _PropertyDescriptors.Add("prod_Name", New Field_prod_Name_Descriptor())
        _PropertyDescriptors.Add("prod_Desc", New Field_prod_Desc_Descriptor())
        _PropertyDescriptors.Add("prod_Price", New Field_prod_Price_Descriptor())
        _PropertyDescriptors.Add("prod_Image", New Field_prod_Image_Descriptor())
        _PropertyDescriptors.Add("prod_IsActive", New Field_prod_IsActive_Descriptor())
        _PropertyDescriptors.Add("prod_Created", New Field_prod_Created_Descriptor())
        _PropertyDescriptors.Add("prod_Version", New Field_prod_Version_Descriptor())

        _AllFieldsList = New List(Of String)(9)
        _AllFieldsList.Add("prod_pk")
        _AllFieldsList.Add("prod_SKU")
        _AllFieldsList.Add("prod_Name")
        _AllFieldsList.Add("prod_Desc")
        _AllFieldsList.Add("prod_Price")
        _AllFieldsList.Add("prod_Image")
        _AllFieldsList.Add("prod_IsActive")
        _AllFieldsList.Add("prod_Created")
        _AllFieldsList.Add("prod_Version")

        _FieldDbTypes = New Dictionary(Of String, DbType)(9)
        _FieldDbTypes.Add("prod_pk", DbType.Int32)
        _FieldDbTypes.Add("prod_SKU", DbType.AnsiString)
        _FieldDbTypes.Add("prod_Name", DbType.String)
        _FieldDbTypes.Add("prod_Desc", DbType.String)
        _FieldDbTypes.Add("prod_Price", DbType.Currency)
        _FieldDbTypes.Add("prod_Image", DbType.Binary)
        _FieldDbTypes.Add("prod_IsActive", DbType.Boolean)
        _FieldDbTypes.Add("prod_Created", DbType.DateTime)
        _FieldDbTypes.Add("prod_Version", DbType.Int32)

        _FieldEnums = New BusinessLayerFieldEnumDictionary(10)
        _FieldEnums.Add("prod_pk", ProductsFieldNames.prod_pk)
        _FieldEnums.Add("prod_SKU", ProductsFieldNames.prod_SKU)
        _FieldEnums.Add("prod_Name", ProductsFieldNames.prod_Name)
        _FieldEnums.Add("prod_Desc", ProductsFieldNames.prod_Desc)
        _FieldEnums.Add("prod_Price", ProductsFieldNames.prod_Price)
        _FieldEnums.Add("prod_Image", ProductsFieldNames.prod_Image)
        _FieldEnums.Add("prod_IsActive", ProductsFieldNames.prod_IsActive)
        _FieldEnums.Add("prod_Created", ProductsFieldNames.prod_Created)
        _FieldEnums.Add("prod_Version", ProductsFieldNames.prod_Version)
        _FieldEnums.Add("CUSTOM_FIELD", ProductsFieldNames.CUSTOM_FIELD)

        _FieldLengths = New Dictionary(Of String, Integer)(9)
        _FieldLengths.Add("prod_pk", 0)
        _FieldLengths.Add("prod_SKU", 20)
        _FieldLengths.Add("prod_Name", 100)
        _FieldLengths.Add("prod_Desc", 1000)
        _FieldLengths.Add("prod_Price", 0)
        _FieldLengths.Add("prod_Image", -1)
        _FieldLengths.Add("prod_IsActive", 0)
        _FieldLengths.Add("prod_Created", 0)
        _FieldLengths.Add("prod_Version", 0)

        _FieldNativeDbTypes = New Dictionary(Of String, Integer)(9)
        _FieldNativeDbTypes.Add("prod_pk", System.Data.SqlDbType.Int)
        _FieldNativeDbTypes.Add("prod_SKU", System.Data.SqlDbType.VarChar)
        _FieldNativeDbTypes.Add("prod_Name", System.Data.SqlDbType.NVarChar)
        _FieldNativeDbTypes.Add("prod_Desc", System.Data.SqlDbType.NVarChar)
        _FieldNativeDbTypes.Add("prod_Price", System.Data.SqlDbType.Money)
        _FieldNativeDbTypes.Add("prod_Image", System.Data.SqlDbType.VarBinary)
        _FieldNativeDbTypes.Add("prod_IsActive", System.Data.SqlDbType.Bit)
        _FieldNativeDbTypes.Add("prod_Created", System.Data.SqlDbType.DateTime)
        _FieldNativeDbTypes.Add("prod_Version", System.Data.SqlDbType.Int)

        _FieldPermissionKeys = New Dictionary(Of String, String)(9)

    End Sub

    Private Shared _AreCustomDescriptorsEvaluated As Boolean = False
    Protected Overrides ReadOnly Property AreCustomDescriptorsEvaluated() As Boolean
        Get
            Dim llReturn As Boolean = _AreCustomDescriptorsEvaluated
            _AreCustomDescriptorsEvaluated = True
            Return llReturn
        End Get
    End Property

    Private Shared _PropertyDescriptors As PropertyDescriptorDictionary
    Protected Overrides ReadOnly Property PropertyDescriptors() As PropertyDescriptorDictionary
        Get
            Return _PropertyDescriptors
        End Get
    End Property

    ''' <summary>
    ''' A private field used to store the System.Type of this business object for use by the FieldPropertyDescriptor classes.
    ''' </summary>
    ''' <remarks></remarks>

    Private Shared _ComponentType As System.Type = GetType(Products)

    ''' <summary>
    ''' A PropertyDescriptor class used to Get and Set the value of the prod_pk property.
    ''' </summary>
    ''' <remarks></remarks>
    Private Class Field_prod_pk_Descriptor
        Inherits MicroFour.StrataFrame.Business.FieldPropertyDescriptor
        Public Sub New()
            MyBase.New("prod_pk")
        End Sub
        Private _PropertyType As System.Type = GetType(System.Int32)
        Public Overrides Function GetValue(ByVal component As Object) As Object
            Return CType(component, Products).prod_pk
        End Function
        Public Overrides Sub SetValue(ByVal component As Object, ByVal Value As Object)
            CType(component, Products).prod_pk = CType(Value, System.Int32)
        End Sub
        Public Overrides ReadOnly Property PropertyType() As System.Type
            Get
                Return Me._PropertyType
            End Get
        End Property
        Public Overrides ReadOnly Property ComponentType() As System.Type
            Get
                Return _ComponentType
            End Get
        End Property
    End Class

    ''' <summary>
    ''' A PropertyDescriptor class used to Get and Set the value of the prod_SKU property.
    ''' </summary>
    ''' <remarks></remarks>
    Private Class Field_prod_SKU_Descriptor
        Inherits MicroFour.StrataFrame.Business.FieldPropertyDescriptor
        Public Sub New()
            MyBase.New("prod_SKU")
        End Sub
        Private _PropertyType As System.Type = GetType(System.String)
        Public Overrides Function GetValue(ByVal component As Object) As Object
            Return CType(component, Products).prod_SKU
        End Function
        Public Overrides Sub SetValue(ByVal component As Object, ByVal Value As Object)
            CType(component, Products).prod_SKU = CType(Value, System.String)
        End Sub
        Public Overrides ReadOnly Property PropertyType() As System.Type
            Get
                Return Me._PropertyType
            End Get
        End Property
        Public Overrides ReadOnly Property ComponentType() As System.Type
            Get
                Return _ComponentType
            End Get
        End Property
    End Class

    ''' <summary>
    ''' A PropertyDescriptor class used to Get and Set the value of the prod_Name property.
    ''' </summary>
    ''' <remarks></remarks>
    Private Class Field_prod_Name_Descriptor
        Inherits MicroFour.StrataFrame.Business.FieldPropertyDescriptor
        Public Sub New()
            MyBase.New("prod_Name")
        End Sub
        Private _PropertyType As System.Type = GetType(System.String)
        Public Overrides Function GetValue(ByVal component As Object) As Object
            Return CType(component, Products).prod_Name
        End Function
        Public Overrides Sub SetValue(ByVal component As Object, ByVal Value As Object)
            CType(component, Products).prod_Name = CType(Value, System.String)
        End Sub
        Public Overrides ReadOnly Property PropertyType() As System.Type
            Get
                Return Me._PropertyType
            End Get
        End Property
        Public Overrides ReadOnly Property ComponentType() As System.Type
            Get
                Return _ComponentType
            End Get
        End Property
    End Class

    ''' <summary>
    ''' A PropertyDescriptor class used to Get and Set the value of the prod_Desc property.
    ''' </summary>
    ''' <remarks></remarks>
    Private Class Field_prod_Desc_Descriptor
        Inherits MicroFour.StrataFrame.Business.FieldPropertyDescriptor
        Public Sub New()
            MyBase.New("prod_Desc")
        End Sub
        Private _PropertyType As System.Type = GetType(System.String)
        Public Overrides Function GetValue(ByVal component As Object) As Object
            Return CType(component, Products).prod_Desc
        End Function
        Public Overrides Sub SetValue(ByVal component As Object, ByVal Value As Object)
            CType(component, Products).prod_Desc = CType(Value, System.String)
        End Sub
        Public Overrides ReadOnly Property PropertyType() As System.Type
            Get
                Return Me._PropertyType
            End Get
        End Property
        Public Overrides ReadOnly Property ComponentType() As System.Type
            Get
                Return _ComponentType
            End Get
        End Property
    End Class

    ''' <summary>
    ''' A PropertyDescriptor class used to Get and Set the value of the prod_Price property.
    ''' </summary>
    ''' <remarks></remarks>
    Private Class Field_prod_Price_Descriptor
        Inherits MicroFour.StrataFrame.Business.FieldPropertyDescriptor
        Public Sub New()
            MyBase.New("prod_Price")
        End Sub
        Private _PropertyType As System.Type = GetType(System.Decimal)
        Public Overrides Function GetValue(ByVal component As Object) As Object
            Return CType(component, Products).prod_Price
        End Function
        Public Overrides Sub SetValue(ByVal component As Object, ByVal Value As Object)
            CType(component, Products).prod_Price = CType(Value, System.Decimal)
        End Sub
        Public Overrides ReadOnly Property PropertyType() As System.Type
            Get
                Return Me._PropertyType
            End Get
        End Property
        Public Overrides ReadOnly Property ComponentType() As System.Type
            Get
                Return _ComponentType
            End Get
        End Property
    End Class

    ''' <summary>
    ''' A PropertyDescriptor class used to Get and Set the value of the prod_Image property.
    ''' </summary>
    ''' <remarks></remarks>
    Private Class Field_prod_Image_Descriptor
        Inherits MicroFour.StrataFrame.Business.FieldPropertyDescriptor
        Public Sub New()
            MyBase.New("prod_Image")
        End Sub
        Private _PropertyType As System.Type = GetType(System.Byte())
        Public Overrides Function GetValue(ByVal component As Object) As Object
            Return CType(component, Products).prod_Image
        End Function
        Public Overrides Sub SetValue(ByVal component As Object, ByVal Value As Object)
            CType(component, Products).prod_Image = CType(Value, System.Byte())
        End Sub
        Public Overrides ReadOnly Property PropertyType() As System.Type
            Get
                Return Me._PropertyType
            End Get
        End Property
        Public Overrides ReadOnly Property ComponentType() As System.Type
            Get
                Return _ComponentType
            End Get
        End Property
    End Class

    ''' <summary>
    ''' A PropertyDescriptor class used to Get and Set the value of the prod_IsActive property.
    ''' </summary>
    ''' <remarks></remarks>
    Private Class Field_prod_IsActive_Descriptor
        Inherits MicroFour.StrataFrame.Business.FieldPropertyDescriptor
        Public Sub New()
            MyBase.New("prod_IsActive")
        End Sub
        Private _PropertyType As System.Type = GetType(System.Boolean)
        Public Overrides Function GetValue(ByVal component As Object) As Object
            Return CType(component, Products).prod_IsActive
        End Function
        Public Overrides Sub SetValue(ByVal component As Object, ByVal Value As Object)
            CType(component, Products).prod_IsActive = CType(Value, System.Boolean)
        End Sub
        Public Overrides ReadOnly Property PropertyType() As System.Type
            Get
                Return Me._PropertyType
            End Get
        End Property
        Public Overrides ReadOnly Property ComponentType() As System.Type
            Get
                Return _ComponentType
            End Get
        End Property
    End Class

    ''' <summary>
    ''' A PropertyDescriptor class used to Get and Set the value of the prod_Created property.
    ''' </summary>
    ''' <remarks></remarks>
    Private Class Field_prod_Created_Descriptor
        Inherits MicroFour.StrataFrame.Business.FieldPropertyDescriptor
        Public Sub New()
            MyBase.New("prod_Created")
        End Sub
        Private _PropertyType As System.Type = GetType(System.DateTime)
        Public Overrides Function GetValue(ByVal component As Object) As Object
            Return CType(component, Products).prod_Created
        End Function
        Public Overrides Sub SetValue(ByVal component As Object, ByVal Value As Object)
            CType(component, Products).prod_Created = CType(Value, System.DateTime)
        End Sub
        Public Overrides ReadOnly Property PropertyType() As System.Type
            Get
                Return Me._PropertyType
            End Get
        End Property
        Public Overrides ReadOnly Property ComponentType() As System.Type
            Get
                Return _ComponentType
            End Get
        End Property
    End Class

    ''' <summary>
    ''' A PropertyDescriptor class used to Get and Set the value of the prod_Version property.
    ''' </summary>
    ''' <remarks></remarks>
    Private Class Field_prod_Version_Descriptor
        Inherits MicroFour.StrataFrame.Business.FieldPropertyDescriptor
        Public Sub New()
            MyBase.New("prod_Version")
        End Sub
        Private _PropertyType As System.Type = GetType(System.Int32)
        Public Overrides Function GetValue(ByVal component As Object) As Object
            Return CType(component, Products).prod_Version
        End Function
        Public Overrides Sub SetValue(ByVal component As Object, ByVal Value As Object)
            CType(component, Products).prod_Version = CType(Value, System.Int32)
        End Sub
        Public Overrides ReadOnly Property PropertyType() As System.Type
            Get
                Return Me._PropertyType
            End Get
        End Property
        Public Overrides ReadOnly Property ComponentType() As System.Type
            Get
                Return _ComponentType
            End Get
        End Property
    End Class

#End Region

End Class

