Imports System.Collections
Imports System.Data
Imports System.Data.SqlClient
Imports System.Runtime.Serialization

Public Enum RSSItems As Integer
    YahooTraffic = 1
End Enum

<Serializable()> _
Public Class YahooWrapper
    Inherits System.Collections.SortedList

    Public Sub New()
        Me.Add("TrafficRSS", "http://maps.yahoo.com/traffic.rss")
    End Sub
    Public Function PopulateMap(ByVal zipCode As String, ByVal miles As Integer, ByVal severity As Integer) As DataTable

        Dim urlPart1 As String = Me("TrafficRSS") + "?csz="
        Dim urlPart2 As String = "&mag="
        Dim urlPart3 As String = "&minsev="
        Dim urlComplete As String = urlPart1 + zipCode + urlPart2 + miles.ToString() + urlPart3 + severity.ToString()

        Dim dtReturn As New DataTable
        Dim dtRSS As New DataTable
        Dim drRSS As DataRow

        Dim ds As New DataSet
        Dim drBuild As DataRow
        Dim i As Integer = 0

        Try
            ds.ReadXml(urlComplete)
            dtRSS = ds.Tables(2)
        Catch ex As Exception
            ds.ReadXml(urlComplete)
            dtRSS = ds.Tables(2)
        End Try

        dtReturn.Columns.Add("latitude")
        dtReturn.Columns.Add("longitude")
        dtReturn.Columns.Add("title")
        dtReturn.Columns.Add("description")
        dtReturn.Columns.Add("severity")
        dtReturn.Columns.Add("category")

        For Each drRSS In dtRSS.Rows()
            drBuild = dtReturn.NewRow()
            drBuild("title") = drRSS("title")
            drBuild("description") = drRSS("description")
            drBuild("severity") = drRSS("severity")
            drBuild("category") = drRSS("category")

            Dim drFound() As String = drRSS("link").ToString().Split("&")
            Dim strPoints As String
            i += 1

            For Each strPoints In drFound
                If strPoints.IndexOf("mlt=") > -1 Then
                    Dim strLat() As String = strPoints.Split("=")
                    drBuild("latitude") = strLat(1)
                End If

                If strPoints.IndexOf("mln=") > -1 Then
                    Dim strLon() As String = strPoints.Split("=")
                    drBuild("longitude") = strLon(1)
                End If
            Next

            '-----------------------------------------------------------------------------
            ' Store a list of Lat and Long strings, we may need them to manipulate the Map
            '-----------------------------------------------------------------------------
            Try
                Me.Add(i.ToString, drBuild("latitude").ToString() + ", " + drBuild("longitude").ToString())
            Catch ex As Exception

            End Try

            dtReturn.Rows.Add(drBuild)

        Next

        Return dtReturn

    End Function

End Class
