﻿<%@ Page Language="vb" AutoEventWireup="false" CodeBehind="Chapter3.aspx.vb" Inherits="SFAnthemAJAXExample.Chapter3" %>

<%@ Register Src="wucSidebar1.ascx" TagName="wucSidebar1" TagPrefix="uc1" %>
<%@ Register Src="wucSidebar2.ascx" TagName="wucSidebar2" TagPrefix="uc2" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">

<head id="Chapter3" runat="server">
    <meta http-equiv="content-type" content="text/html; charset=utf-8" />
    <title>SF - AJAX Communnity Sample: Chapter 3</title>
    <meta name="keywords" content="" />
    <meta name="description" content="" />

    <link href="CSS/default.css" rel="stylesheet" type="text/css" media="screen" />
    <link href="CSS/SFAJAX.css" rel="stylesheet" type="text/css" media="screen" />

    <script src="Scripts/SFAJAX.js" type="text/javascript" ></script>

    
    <script type="text/javascript" language="javascript" >
        
        function bodyLoad()
            {
            }

        function sayHello()
        {
            var name;
            name = document.getElementById("txtName").value;
            alert("Hello " + name + "! I'm not Anthem; however, I'll introduce you later!");
           
        }       
        
        function sayHelloAnthem()
        {
        var findName = document.getElementById("txtAnthemName");
        Anthem_InvokePageMethod('SayHelloAnthem',[findName.value], sayHiACB);
        }

        /* 
        ------------------------
        sayHelloAnthemCallback()
        ------------------------
        */
        function sayHiACB(response)
        {
        alert(response.value);
        }
                     
    </script>
    
</head>

<body onload="bodyLoad()" id="cmdIntroduction">
    <form id="frmChapterThree" runat="server">
    
        <span id="AjaxMessage"></span>
        
        <div id="wrapper">
	                <!-- start menu -->
	                <div id="menu">
		                <ul>
			                <li><a href="Default.aspx">Home</a></li>
			                <li><a href="Contact.aspx">Contact</a></li>
		                </ul>
	                </div>
	                <!-- end menu -->
	                <!-- start header -->
	                <div id="header">
		                <div id="logo">
			                <h1><img src="Images/SFHeader.jpg" alt=""/></h1>
			                <p>with 
			                    <span style="color: #990000">
			                    <strong>AJAX</strong>
			                    <br />
                                </span>
                                <br />
                                <span style="font-size: 0.65em">
                                A free sample by Charles T. Blankenship & Anthony Somma
                                </span>
                            </p>
		                </div>
	                </div>
	                <!-- end header -->
	                <!-- start page -->
	                <div id="page">
		                <div id="bgtop"></div>
		                <div id="bgbottom">
			                <!-- start content -->
			                <div id="content" style="width: 695px">
				                <div class="post">
					                <div class="bigpix">
						                <div class="image"><img src="Images/FireFlies.png" alt="" height="250" style="width: 695px" /></div>
						                <p class="caption">
                                            What is this Anthem thing and why is it important?</p>
					                </div>
					                <h1 class="title"><a href="#">Chapter 3: A JavaScript "Hello Anthem!" example</a></h1>
					                <div class="entry">
						                <strong>

                                        In the previous examples, using the raw XmlHTTPRequest (XHR) object, you'll notice
                                        that you have to have TWO aspx pages (at least) for each page that presents information
                                        to the user.  The reason for this is that the XHR requires the hosting page, it also
                                        requires a page on the server, different from the calling (hosting)
                                            page, that the XHR references
                                        for the asynchronous call back to the server.  In some cases this is good, in some cases it
                                        is bad, this is why we need many tools in our toolbox.  This chapter shows how to 
                                        reduce this one to many page relationship to a one to one, thereby reducing your 
                                        maintenance burden ... using Anthem.
						                <br />                                        
                                        <br />
                                        </strong>
                                        
                                        <h2>anthem: What is it?</h2>

                                        <p>
                                            Anthem is a third party AJAX framework, that is free and that provides the source
                                            code for the framework to the community, much like StrataFrame for AJAX but without the annual payments required (sorry Trent, what's a slight jab between friends,
                                            eh?).&nbsp; It wraps itself around the web page and incorporates AJAX (the XHR)
                                            into it automatically.&nbsp; All you have to do is download this framework from
                                            SourceForge (see Introduction for instructions), recompile the application and drop
                                            the resulting .dll in your project's <strong>bin</strong> folder.&nbsp;
                                            
                                        </p>
                                        <p>
                                            What is the benefit to this?&nbsp; The primary benefit is that you can now place
                                            all of the AJAX calls in the code behind page instead of on a completely separate
                                            page that resides on the server solely for that purpose.&nbsp; In Chapter 1 we <em>wanted</em>
                                            that separate page because it is much easier to maintain the popup message box of
                                            Customer Information in the VS 2005 design environment than it is to maintain a
                                            bunch of HTML tags strung together using string builder.&nbsp; However, if we used
                                            this model for every aspect of the application the
                                        number of ASPX pages in the application
                                            would more than double for each page that required an AJAX call ... from my perspective,
                                            that is not good, Anthem is the solution.</p>
                                        <h2>
                                            how to hook anthem up to a page</h2>
                                        <p>
                                            Every page that you want to use Anthem with you must include a registration call
                                            to Anthem in the Page_Load event.&nbsp; For example, the Page_Load event for this
                                            page looks like this:</p>
                                        <p style="text-align: center">
                                            <asp:Image ID="imgChapter3_1" runat="server" ImageUrl="~/Images/Chapter3_1.png" />&nbsp;</p>
                                        <p>
                                            We are now ready to use Anthem in the examples for this page.</p>
                                        <h2>
                                        </h2>
                                        <h2>
                                            a simple javascript "hello world" illustration</h2>
                                        <p>
                                        The following illustration is a simple JavaScript "Hello World" application.&nbsp;
                                            It is going to ask you to enter your first name, then you should press the "Hello
                                            Anthem" button ... Anthem will respond, you two are now properly introduced to one
                                            another and we can get on with the examples.</p>
                                            <table border="0" cellpadding="0" cellspacing="0">
                                                <tr>
                                                    <td style="width: 164px; padding-left: 5px; padding-bottom: 5px; padding-top: 5px;">
                                                        Please enter your name:</td>
                                                    <td style="width: 160px; padding-right: 5px; padding-bottom: 5px; padding-top: 5px;">
                                                        <input id="txtName" 
                                                               type="text" />
                                                        </td>
                                                    <td style="width: 100px; padding-bottom: 5px; padding-top: 5px;">
                                                        <input id="cmdHelloAnthem" 
                                                               type="button" 
                                                               value="Hello Anthem!" 
                                                               onclick="sayHello()" />
                                                    </td>
                                                </tr>
                                            </table>
                                        <br />
                                        <p>
                                            The HTML markup for this simple illustration looks like this, note the "onclick"
                                            JavaScript call to the sayHello() function:</p>
                                        <p style="text-align: center"><asp:Image ID="imgChapter3_2" runat="server" ImageUrl="~/Images/Chapter3_2.png" />&nbsp;</p>
                                        <p>
                                            The JavaScript sayHello() function looks like this:</p>
                                        <p style="text-align: center">
                                            &nbsp;<asp:Image ID="imgChapter3_3" runat="server" ImageUrl="~/Images/Chapter3_3.png" /></p>
                                        
                                        <p >
                                        The sayHello() function simply takes the value entered into the txtName textbox
                                            and injects it into the greeting string that is fed to the JavaScript alert() function
                                            ... the result is that you get a nice welcoming message letting you know that Anthem
                                            is on the way.&nbsp; For you VB'ers out there, one of the things that is going to
                                            drive you crazy is the requirement that JavaScript has that every command line must
                                            be terminated with a semicolon (innate for C# and C++ people).</p>

                                        <h2>same thing, but now with anthem</h2>

                                        <table border="0" cellpadding="0" cellspacing="0">
                                            <tr>
                                                <td style="width: 164px; padding-left: 5px; padding-bottom: 5px; padding-top: 5px;">
                                                    Please enter your name:</td>
                                                <td style="width: 160px; padding-right: 5px; padding-bottom: 5px; padding-top: 5px;">
                                                    <input id="txtAnthemName" 
                                                           type="text" />
                                                </td>
                                                <td style="width: 100px; padding-bottom: 5px; padding-top: 5px;">
                                                    <input id="cmdImAmthem" 
                                                           type="button" 
                                                           value="Hello Anthem!" 
                                                           onclick="sayHelloAnthem()" />
                                                </td>
                                            </tr>
                                        </table>

                                        <br />
                                        The HTML for this first Anthem example is just as simple as before, the button is
                                        simply calling a different JavaScript function<br />
                                        <br />

                                        <p style="text-align: center">
                                            <img src="Images/Chapter3_4.png" alt="" />
                                        </p>

                                        <p>
                                        The JavaScript function calls are a bit different though, here they are:
                                        </p>

                                        <p style="text-align: center">
                                            <img src="Images/Chapter3_5.png" alt=""/>
                                        </p>
                                        <p>
                                            The primary function call used to communicate with the codebehind of your ASPX page
                                            is the Anthem_InvokePageMethod().&nbsp; The first parameter is the name of the method
                                            in the code behind page.&nbsp; The second parameter is the value you are passing
                                            into the function (in this case the name you typed into the text box).&nbsp; The
                                            third parameter is the name of the JavaScript function that processes the value
                                            returned from the SayHelloAnthem() method in the code behind.&nbsp; In this siuation,
                                            sayHiACB is simply displaying an alert using the return value from this function.
                                        </p>
                                        
                                        <p style="text-align: center">
                                            <img src="Images/Chapter3_6.png" alt=""/>
                                        </p>
                                        
                                        <p>
                                        The only thing you have to do to make one of your code behind methods into a method
                                            that can be called by Anthem is to put the "&lt;Anthem.Method()&gt; _ " qualifier
                                            before the method declaration. &nbsp;The next thing you may ask is, "What can be
                                            returned from this method"?&nbsp; The answer is pretty much anything: dataset, datatable,
                                            XML, simple strings, HTML and JSON objects are just a vew examples.</p>
                                        <p>
                                            Welcome to the world of Anthem AJAX!</p>
                                        <p>
                                            In the next chapter I'll show you how to duplicate Google's suggest functionality
                                            using the StrataFrame Sample database Customer table.</p>
                                    </div>
                					
				                </div>
				                
			                </div>
			                <!-- end content -->
			                <!-- start sidebar one -->
			                <!-- end sidebar one -->
			                <!-- start sidebar two -->
			                <uc2:wucSidebar2 ID="WucSidebar2_1" runat="server" />
			                <div style="clear: both;">&nbsp;</div>	
			                <!-- end sidebar two -->
		                </div>
	                </div>
	                <!-- end page -->
	                <hr />
	                <!-- start footer -->
	                <div id="footer">
	                </div>
	                <!-- end footer -->
                </div>
    </form>
</body>
</html>

