﻿<%@ Page Language="vb" AutoEventWireup="false" CodeBehind="Chapter4.aspx.vb" Inherits="SFAnthemAJAXExample.Chapter4" %>

<%@ Register Src="wucSidebar1.ascx" TagName="wucSidebar1" TagPrefix="uc1" %>
<%@ Register Src="wucSidebar2.ascx" TagName="wucSidebar2" TagPrefix="uc2" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">

<head id="Chapter4" runat="server">
    <meta http-equiv="content-type" content="text/html; charset=utf-8" />
    <title>SF - AJAX Communnity Sample: Chapter 4</title>
    <meta name="keywords" content="" />
    <meta name="description" content="" />

    <link href="CSS/default.css" rel="stylesheet" type="text/css" media="screen" />
    <link href="CSS/SFAJAX.css" rel="stylesheet" type="text/css" media="screen" />

    <script src="Scripts/SFAJAX.js" type="text/javascript" ></script>

    
    <script type="text/javascript" language="javascript" >
        
        /* 
        ----------------------------------------------------------------------------------------
        This method simply initializes the form on load so that the DIV named "searchresults"
        is hidden when the body of the document first loads and that the "keyword" text box
        receives focus ready for typing.  Examine the <body> tag below to see how this is called.
        -----------------------------------------------------------------------------------------
        */
        function bodyLoad()
        {
            HideControl("searchresults");
            document.getElementById("keyword").focus();
        }

        function LoadResults(searchterm)
        {
            if (searchterm.length == 0)
            {
                ClearResults("searchresults");
                HideControl("searchresults");
                return;
            }
            
            Anthem_InvokePageMethod('RetrieveRows',[searchterm], LoadResultsCallback);
        }

        function LoadResultsCallback(result)
        {
            ShowControl("searchresults");
            ClearResults("searchresults");

            var divResults = document.getElementById("searchresults");
            var tblTable = document.createElement("table");
            var tablebody = document.createElement("tbody");
            var tablerow, tablecell, tablenode;
            
            if(typeof(result.error) == 'string')
            {
                var currenttext = result.error;
                tablerow = document.createElement("tr");
                tablecell = document.createElement("td");
                tablenode = document.createTextNode(currenttext);
                tablecell.appendChild(tablenode);
                tablerow.appendChild(tablecell);
                tablebody.appendChild(tablerow);                    
                tblTable.appendChild(tablebody);
                divResults.appendChild(tblTable);
                return;	
            }
                        
            var items = result.value;
            var count = items.Rows.length;
            
            for ( var i = 0; i < count; i++)
            {
                var currenttext = items.Rows[i].CustomerName;
              
                tablerow = document.createElement("tr");
                tablecell = document.createElement("td");
                tablecell.onmouseover = function(){this.className='gsMouseOver';};
                tablecell.onmouseout = function(){this.className='gsMouseOut';};
                tablecell.setAttribute("border","0");
                tablecell.onclick = function(){ReplaceInput(this);};
                tablenode = document.createTextNode(currenttext);
                tablecell.appendChild(tablenode);
                tablerow.appendChild(tablecell);
                tablebody.appendChild(tablerow);
            }
            tblTable.appendChild(tablebody);
            divResults.appendChild(tblTable);
        }

        function ReplaceInput(tablecell)
        {
            var inputbox = document.getElementById("keyword");
            inputbox.value = tablecell.firstChild.nodeValue;
            ClearResults("searchresults");
            HideControl("searchresults");
        }
                        
    </script>
    
</head>

<body onload="bodyLoad()">

    <form id="frmChapterFour" runat="server">
    
        <span id="AjaxMessage"></span>
        
        <div id="wrapper">
	                <!-- start menu -->
	                <div id="menu">
		                <ul>
			                <li><a href="Default.aspx">Home</a></li>
			                <li><a href="Contact.aspx">Contact</a></li>
		                </ul>
	                </div>
	                <!-- end menu -->
	                <!-- start header -->
	                <div id="header">
		                <div id="logo">
			                <h1><img src="Images/SFHeader.jpg" alt=""/></h1>
			                <p>with 
			                    <span style="color: #990000">
			                    <strong>AJAX</strong>
			                    <br />
                                </span>
                                <br />
                                <span style="font-size: 0.65em">
                                A free sample by Charles T. Blankenship & Anthony Somma
                                </span>
                            </p>
		                </div>
	                </div>
	                <!-- end header -->
	                <!-- start page -->
	                <div id="page">
		                <div id="bgtop"></div>
		                <div id="bgbottom">
			                <!-- start content -->
			                <div id="content" style="width: 695px">
				                <div class="post">
					                <div class="bigpix">
						                <div class="image"><img src="Images/FireFlies.png" alt="" height="250" style="width: 695px" /></div>
						                <p class="caption">
                                            What is this Anthem thing and why is it important?</p>
					                </div>
					                <h1 class="title"><a href="#">Chapter 4: A Google Suggest Example</a></h1>
					                <div class="entry">

						                <strong>
						                Google Suggest allows you to type a search term into a text box.  It then looks into 
						                the Google database for other popular entries that match or closely match the search
						                string that you just entered and displays them to you ... all without a postback to the server.&nbsp; That is the function this example will recreate with one caveat,
                                            we will be using the Customers table in StrataFrame's sample database instead of hacking into Google's database.
						                <br />                                        
                                        <br />
                                        </strong>
                                        
                                        <h2>
                                        </h2>
                                        <strong style="font-family: Arial"></strong>
                                        <h2>
                                            google suggest demonstration</h2>
                                        <strong style="font-family: Arial"></strong>
                                        <table border="0" 
                                               cellpadding="0" 
                                               cellspacing="0">
                                            <tr>
                                                <td>
                                                    Enter the name of a StrataFrame Customer:
                                                </td>
                                            </tr>
                                            <tr>
                                                <td>
                                                    <asp:TextBox ID="keyword" 
                                                                 runat="server" 
                                                                 Width="400px" ></asp:TextBox>
                                                </td>
                                            </tr>
                                            <tr>
                                                <td style="height: 100%">
                                                    <div class="box" 
                                                         id="searchresults" 
                                                         style=" text-align:left;height:100%;width:100%;background-color:#e0edf6; font-size: 12px; font-family: Arial;">
                                                    </div>
                                                </td>
                                            </tr>
                                        </table>

                                    </div>
                					
				                </div>
				                
			                </div>
			                <!-- end content -->
			                <!-- start sidebar one -->
			                <!-- end sidebar one -->
			                <!-- start sidebar two -->
			                <uc2:wucSidebar2 ID="WucSidebar2_1" runat="server" />
			                <!-- end sidebar two -->
			                <div style="clear: both;">&nbsp;</div>
		                </div>
	                </div>
	                <!-- end page -->
	                <hr />
	                <!-- start footer -->
	                <div id="footer">
	                </div>
	                <!-- end footer -->
                </div>
    </form>
</body>
</html>
