<%@ Page Language="vb" AutoEventWireup="false" CodeBehind="SimpleSFAJAXExample.aspx.vb" Inherits="SFAnthemAJAXExample._Default" %>

<%@ Register Src="WUC/ucNameTest.ascx" TagName="ucNameTest" TagPrefix="uc1" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml" >
<head runat="server" >

    <title>Default AJAX Test Page</title>
    
    <style type="text/css">
        .mouseOut
        {
            background: #cecece; color: #000000; width: 200px
        }
        
        .mouseOver
        {
            background: #fffafa; color: #000000; width: 200px
        }
        
        .NFTitleCell
        { 
            background: #cecece; width: 200px
        }
        
        .NFDescriptionCell
        { 
            background: #ececec
        }

        .fixedtipdiv
        {
            position:absolute;
            padding: 2px;
            border:1px solid black;
            font:normal 12px Verdana;
            line-height:18px;
            z-index:100;
        }
        
        .section  
        {
          position:relative; /*this is the key*/
          z-index:24;
        }

        .section:hover 
        {
          z-index:25;
        }

        .section span
        {
          display: none;
        }

        .section:hover span 
        { /*the span will display just on :hover state*/
          display:block;
          position:absolute;
        }

                    .tip {font:10px/12px
                    Arial,Helvetica,sans-serif; border:solid 1px
                    #666666; width:270px; padding:1px;
                    position:absolute; z-index:100;
                    visibility:hidden; color:#333333; top:20px;
                    left:90px; background-color:#ffffcc;
                    layer-background-color:#ffffcc;}
                  
        .tooltip 
        {
            padding: 3px;
            background: #f9f9f9;
            border: 1px solid #eeeeee;
            text-align: center;
            font-size: smaller;
        }

        .spantip 
        {
            border-bottom: 1px solid #eeeeee;
            color: #000000;
        }

    </style>

    <script type="text/javascript" language="javascript">

        /* 
        ----------------------------------------------------------------------------------------
        This method simply initializes the form on load so that the DIV named "searchresults"
        is hidden when the body of the document first loads and that the "keyword" text box
        receives focus ready for typing.  Examine the <body> tag below to see how this is called.
        -----------------------------------------------------------------------------------------
        */
        function BodyLoad()
        {
            HideControl("searchresults");
            HideControl("divNetFlix");
            HideControl("imgNetFlixRefreshing");
            document.getElementById("keyword").focus();
        }
        
        
        /* 
        --------------------------------------------------------------------------------
        This function illustrates how the onclick method of a button can be used to call 
        a JavaScript function, use JavaScript to strip the value out of a control that 
        is in the document and then use another JavaScript function, alert() do display
        a message.  As the title implies, no AJAX is involved in this.
        --------------------------------------------------------------------------------
        */        
        function btnGoOnClickNoAJAX()
        {
            var findName = document.getElementById("txtNameNoAJAX");
            alert('Hello ' + findName.value + '!');
        }


        /* 
        -------------------------------------------------------------------------------------------------
        
        Anthem_InvokePageMethod( [CodeBehindMethodToCall], [parameters], [JavaScriptReceivingMethodName])
        
        CodeBehindMethodToCall: "_Default.SayHello()", look at the codebehind for this page and 
                                find a method with this name and check out what it does.
        Parameter: "findName.Value", the name entered by the user in the txtName text box
        JavaScriptReceivingMethodName: "btnGoOnClickAJAXCallback", the JavaScript method that handles
                                        the value returned by the CodeBehindMethodToCall, in this case
                                        a modified text string that prepends the word Hello to the name.
                                        As you will see shortly, this is the hook into StrataFrame.
                                        Just about anything can be returned from this method, a string,
                                        a number, a datatable, a dataset, XML, JSON object, anything.
        -------------------------------------------------------------------------------------------------
        */  
        function btnGoOnClickAJAX()
        {
            var findName = document.getElementById("txtName");
            Anthem_InvokePageMethod('SayHello',[findName.value], btnGoOnClickAJAXCallback);
        }

        function btnGoOnClickAJAXCallback(response)
        {
           alert(response.value);
        }

        function LoadNetFlixNewReleases() 
        {
            var NetFlixURL = document.getElementById("txtNetflixURL");
            HideControl("imgRefreshNewReleases")
            ShowControl("imgNetFlixRefreshing")
            Anthem_InvokePageMethod('GetNetflixNewReleases',[NetFlixURL.value], ProcessNetFlixNewReleases);
        }

        function ProcessNetFlixNewReleases( NewReleases )
        {
            ClearResults("divNetFlix");
            ShowControl("divNetFlix");
            ShowControl("imgRefreshNewReleases");

            var items = NewReleases.value;
            var count = items.Rows.length;
            
            var divResults = document.getElementById("divNetFlix");
            var tblTable = document.createElement("table");
            var tablebody = document.createElement("tbody");
            var tablerow, tablecell, tablecell2, NFTitleText, tablenode2;

            if (count == 0)
                {
                    var currenttext = "No new NetFlix titles available";
                    tablerow = document.createElement("tr");
                    tablecell = document.createElement("td");
                    tablenode = document.createTextNode(currenttext);
                    tablecell.appendChild(tablenode);
                    tablerow.appendChild(tablecell);
                    tablebody.appendChild(tablerow);                    
                    tblTable.appendChild(tablebody);
                    divResults.appendChild(tblTable);	
                }
            else
                {
                    for ( var i = 0; i < count; i++)
                        {
                          
                            tablerow = document.createElement("tr");
                            
                            tablecell = document.createElement("td");                            
                            tablecell.onmouseover = function(){this.className='mouseOver';};
                            tablecell.onmouseout = function(){this.className='mouseOut';};
                            tablecell.className = "NFTitleCell";
                                                     
                            tablecell2 = document.createElement("td");
                            tablecell2.className = "NFDescriptionCell";

                            var NFTitle = items.Rows[i].nf_title;                            
                            NFTitleText = document.createTextNode(NFTitle);

                            var titleLink = document.createElement('a')
                            titleLink.setAttribute('href',items.Rows[i].nf_link);
                                                        
                            titleLink.appendChild(NFTitleText)
                            
                            tablecell.appendChild(titleLink);
                            tablerow.appendChild(tablecell);
                            
                            var cell2Text = items.Rows[i].nf_description;                            
                            tablenode2 = document.createTextNode(cell2Text);
                            tablecell2.appendChild(tablenode2);
                            tablerow.appendChild(tablecell2);
                            
                            tablebody.appendChild(tablerow);
                        }
                        
                        tblTable.appendChild(tablebody);
                        divResults.appendChild(tblTable);	
                }
                   
                HideControl("imgNetFlixRefreshing");
        }            
            
                
        function LoadResultsCallback(result)
        {
            ShowControl("searchresults");
            ClearResults("searchresults");
            
            var items = result.value;
            var count = items.Rows.length;
            
            var divResults = document.getElementById("searchresults");
            var tblTable = document.createElement("table");
            var tablebody = document.createElement("tbody");
            var tablerow, tablecell, tablenode;
            
            for ( var i = 0; i < count; i++)
            {
                var currenttext = items.Rows[i].CustomerName;
              
                tablerow = document.createElement("tr");
                tablecell = document.createElement("td");
                tablecell.onmouseover = function(){this.className='mouseOver';};
                tablecell.onmouseout = function(){this.className='mouseOut';};
                tablecell.setAttribute("border","0");
                tablecell.onclick = function(){ReplaceInput(this);};
                tablenode = document.createTextNode(currenttext);
                tablecell.appendChild(tablenode);
                tablerow.appendChild(tablecell);
                tablebody.appendChild(tablerow);
            }
            tblTable.appendChild(tablebody);
            divResults.appendChild(tblTable);
        }

        function ReplaceInput(tablecell)
        {
            var inputbox = document.getElementById("keyword");
            inputbox.value = tablecell.firstChild.nodeValue;
            ClearResults("searchresults");
            HideControl("searchresults");
        }

        function ClearResults(divName)
        {
            var resultsdiv = document.getElementById(divName);
            var counter = resultsdiv.childNodes.length;
            for (var i = counter -1; i >= 0; i--)
            {
                resultsdiv.removeChild(resultsdiv.childNodes[i]);
            }
        }

        function LoadResults(searchterm)
        {
            if (searchterm.length == 0)
            {
                ClearResults("searchresults");
                HideControl("searchresults");
                return;
            }
            
            Anthem_InvokePageMethod('RetrieveRows',[searchterm], LoadResultsCallback);
        }
        
        function ShowControl(controlID)
        {
        if (document.layers) 
           document.layers[controlid].visibility="show";
        else 
           document.getElementById(controlID).style.visibility="visible";
        }

        function HideControl(controlID)
        {
        if (document.layers) 
           document.layers[controlid].visibility="hide";
        else 
           document.getElementById(controlID).style.visibility="hidden";
        }

        var offsetx = 12;
        var offsety =  8;

        function newelement(newid)
        { 
            if(document.createElement)
            { 
                var el = document.createElement('div'); 
                el.id = newid;     
                with(el.style)
                { 
                    display = 'none';
                    position = 'absolute';
                } 
                el.innerHTML = '&nbsp;'; 
                document.body.appendChild(el); 
            } 
        } 
        var ie5 = (document.getElementById && document.all); 
        var ns6 = (document.getElementById && !document.all); 
        var ua = navigator.userAgent.toLowerCase();
        var isapple = (ua.indexOf('applewebkit') != -1 ? 1 : 0);
        
        function getmouseposition(e)
        {
            if(document.getElementById)
            {
                var iebody=(document.compatMode && 
        	        document.compatMode != 'BackCompat') ? 
        		        document.documentElement : document.body;
                pagex = (isapple == 1 ? 0:(ie5)?iebody.scrollLeft:window.pageXOffset);
                pagey = (isapple == 1 ? 0:(ie5)?iebody.scrollTop:window.pageYOffset);
                mousex = (ie5)?event.x:(ns6)?clientX = e.clientX:false;
                mousey = (ie5)?event.y:(ns6)?clientY = e.clientY:false;

                var lixlpixel_tooltip = document.getElementById('tooltip');
                lixlpixel_tooltip.style.left = (mousex+pagex+offsetx) + 'px';
                lixlpixel_tooltip.style.top = (mousey+pagey+offsety) + 'px';
            }
        }
        
        function tooltip(tip)
        {
            if(!document.getElementById('tooltip')) newelement('tooltip');
            var lixlpixel_tooltip = document.getElementById('tooltip');
            lixlpixel_tooltip.innerHTML = tip;
            lixlpixel_tooltip.style.display = 'block';
            document.onmousemove = getmouseposition;
        }
        
        function exit()
        {
            document.getElementById('tooltip').style.display = 'none';
        }
                    
    </script>
</head>

<body onload="BodyLoad();">

    <form id="frmMain" runat="server">
    <div>
    
        <table border="0" 
               cellpadding="0" 
               cellspacing="0" 
               style="padding-right: 5px; padding-left: 5px; padding-bottom: 5px; width: 254px; padding-top: 5px; height: 25px">
            <tr>
                <td colspan="3" style="font-weight: bold; font-size: 14px; color: #00008b; border-bottom: black 1px dotted;
                    font-family: Arial; height: 20px; background-color: #E0EDF6">
                    Non AJAX Method</td>
            </tr>
            <tr>
                <td style="width: 150px; height: 34px">
                    <asp:Label ID="lblName1" 
                               runat="server" 
                               Text="Enter your name:" 
                               Width="128px" Font-Names="Arial" Font-Size="10pt">
                    </asp:Label>
                </td>
                <td style="width: 100px; height: 34px">
                    <asp:TextBox ID="txtNameNoAJAX" 
                                 runat="server" 
                                 Width="92px">
                    </asp:TextBox>
                </td>
                <td style="width: 100px; height: 34px">
                    <input id="btnSayHelloNoAJAX" 
                           type="button" 
                           value="Say Hello (No AJAX)" 
                           onclick="btnGoOnClickNoAJAX();" /></td>
            </tr>
            <tr>
                <td colspan="3" style="font-weight: bold; font-size: 14px; color: #00008b; border-bottom: black 1px dotted;
                    font-family: Arial; height: 20px; background-color: #E0EDF6">
                    AJAX Method</td>
            </tr>
            <tr>
                <td style="width: 150px; height: 34px;">
                    <asp:Label ID="lblName2" 
                               runat="server" 
                               Text="Enter your name:" 
                               Width="128px" 
                               Font-Names="Arial" 
                               Font-Size="10pt">
                    </asp:Label></td>
                <td style="width: 100px; height: 34px;">
                    <asp:TextBox ID="txtName" 
                                 runat="server" 
                                 Width="92px">
                    </asp:TextBox></td>
                <td style="width: 100px; height: 34px;">
                    <input id="btnGo" 
                           type="button" 
                           value="Say Hello" 
                           onclick="btnGoOnClickAJAX();" />
                </td>
            </tr>
            <tr>
                <td colspan="3" style="height: 34px">
                    <span class="spantip"
                          onmouseover="tooltip('here comes the explanation');"
                          onmouseout="exit();">A tooltip is going to popup here.</span>
                </td>
            </tr>
        </table>
        <br />
        <table border="0" 
               cellpadding="0" 
               cellspacing="0" 
               style="padding-right: 5px; padding-left: 5px; padding-bottom: 5px; width: 254px; padding-top: 5px; height: 25px">
            <tr>
                <td colspan="3" style="font-weight: bold; font-size: 14px; color: #00008b; border-bottom: black 1px dotted;
                    font-family: Arial; height: 20px; background-color: #E0EDF6">
                    <table border="0" cellpadding="0" cellspacing="0">
                        <tr>
                            <td style="width: 200px">
                                Netflix Existing Titles</td>
                            <td style="width: 100px; font-size: 10px; color: black; font-family: Arial; padding-right: 3px; padding-left: 3px; padding-bottom: 3px; padding-top: 3px;">
                                Begins With:</td>
                            <td style="width: 100px; font-size: 10px; color: black; font-family: Arial; padding-right: 3px; padding-left: 3px; padding-bottom: 3px; padding-top: 3px;">
                                Start Date:</td>
                            <td style="width: 100px; font-size: 10px; color: black; font-family: Arial; padding-right: 3px; padding-left: 3px; padding-bottom: 3px; padding-top: 3px;">
                                End Date:</td>
                            <td style="width: 25px; font-weight: bold; font-size: 10px; color: #000000; font-family: Arial">
                                <SFWeb:Image ID="cmdGetExisting" 
                                     runat="server" 
                                     ImageUrl="~/Images/Refresh.png"
                                     ToolTip="Get existing NetFlix titles" /></td>
                            <td style="width: 100px; font-weight: bold; font-size: 10px; color: #000000; font-family: Arial"><SFWeb:Image ID="imgExistingTitlesRefreshing" 
                                 runat="server" 
                                 ImageUrl="~/Images/loadingbar1.gif"
                                 ToolTip="Refresh new releases from NetFlix" Visible="False" /></td>
                        </tr>
                        <tr>
                            <td style="width: 100px">
                            </td>
                            <td style="width: 100px; padding-right: 3px; padding-left: 3px; font-size: 10px; padding-bottom: 3px; color: black; padding-top: 3px; font-family: Arial;">
                                <select id="ddlLetter" style="width: 45px">
                                    <option value="" selected="selected"></option>
                                    <option value="A">A</option>
                                    <option value="B">B</option>
                                    <option value="C">C</option>
                                    <option value="D">D</option>
                                    <option value="E">E</option>
                                    <option value="F">F</option>
                                    <option value="G">G</option>
                                    <option value="H">H</option>
                                    <option value="I">I</option>
                                    <option value="J">J</option>
                                    <option value="K">K</option>
                                    <option value="L">L</option>
                                    <option value="M">M</option>
                                    <option value="N">N</option>
                                    <option value="O">O</option>
                                    <option value="P">P</option>
                                    <option value="Q">Q</option>
                                    <option value="R">R</option>
                                    <option value="S">S</option>
                                    <option value="T">T</option>
                                    <option value="U">U</option>
                                    <option value="V">V</option>
                                    <option value="W">W</option>
                                    <option value="X">X</option>
                                    <option value="Y">Y</option>
                                    <option value="Z">Z</option>
                                    <option value="1">1</option>
                                    <option value="2">2</option>
                                    <option value="3">3</option>
                                    <option value="4">4</option>
                                    <option value="5">5</option>
                                    <option value="6">6</option>
                                    <option value="7">7</option>
                                    <option value="8">8</option>
                                    <option value="9">9</option>
                                    <option value="0">0</option>
                                </select>
                            </td>
                            <td style="width: 100px; padding-right: 3px; padding-left: 3px; font-size: 10px; padding-bottom: 3px; color: black; padding-top: 3px; font-family: Arial;">
                                <asp:TextBox ID="txtStartDate" runat="server" Width="65px"></asp:TextBox></td>
                            <td style="width: 100px; padding-right: 3px; padding-left: 3px; font-size: 10px; padding-bottom: 3px; color: black; padding-top: 3px; font-family: Arial;">
                                <asp:TextBox ID="txtEndDate" runat="server" Width="65px"></asp:TextBox></td>
                            <td style="width: 25px">
                            </td>
                            <td style="width: 100px">
                            </td>
                        </tr>
                    </table>
                </td>
            </tr>
            <tr>
                <td colspan="3" 
                    style="font-weight: bold; font-size: 14px; color: #00008b; border-bottom: black 1px dotted; font-family: Arial; height: 20px; background-color: #E0EDF6">
                    <table border="0" cellpadding="0" cellspacing="0">
                        <tr>
                            <td style="width: 160px">
                    Netflix New Releases</td>
                            <td style="width: 25px">
                    <SFWeb:Image ID="imgRefreshNewReleases" 
                                 runat="server" 
                                 ImageUrl="~/Images/Refresh.png"
                                 ToolTip="Refresh new releases from NetFlix" /></td>
                            <td align="right" valign="middle"><SFWeb:Image ID="imgNetFlixRefreshing" 
                                 runat="server" 
                                 ImageUrl="~/Images/loadingbar1.gif"
                                 ToolTip="Refresh new releases from NetFlix" />
                            </td>
                        </tr>
                    </table>
                </td>
            </tr>
            <tr>
                <td style="height: 34px" colspan="3">
                    &nbsp;
                    <SFWeb:TextBox ID="txtNetflixURL" 
                                   runat="server" 
                                   Width="655px" 
                                   Font-Names="Courier New">http://www.netflix.com/NewReleasesRSS
                    </SFWeb:TextBox></td>
            </tr>
            <tr>
                <td colspan="3">
                    <div id="divNetFlix" 
                         class="box" 
                         style="font-size: 12px; width: 100%; font-family: Arial; height: 100%; background-color: #e0edf6; text-align: left">
                    </div>
                </td>
            </tr>
        </table>
        <br />
        <span style="font-size: 24pt; font-family: Arial;">AJAX.NET</span><br />
        <strong style="font-family: Arial">Google Suggest Demo<br /></strong>
            <table border="0" 
                   cellpadding="0" 
                   cellspacing="0">
                <tr>
                    <td>
                        <asp:TextBox ID="keyword" 
                                     runat="server" 
                                     Width="403px" >
                        </asp:TextBox>
                    </td>
                </tr>
                <tr>
                    <td style="height: 100%">
                        <div class="box" 
                             id="searchresults" 
                             style=" text-align:left;height:100%;width:100%;background-color:#e0edf6; font-size: 12px; font-family: Arial;">
                        </div>
                    </td>
                </tr>
            </table>
        
        </div>
        

    </form>
</body>
</html>




